package net.lecnam.info;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Client implements Runnable {

	DataInputStream in;
	DataOutputStream out;

	Client(DataInputStream in, DataOutputStream out) {
		this.in = in;
		this.out = out;
	}

	public int size() {
		try {
			out.writeInt(-2);
			int s = in.readInt();
			return s;
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}

	public Integer get(int index) {
		try {
			out.writeInt(index);
			int elt = in.readInt();
			return elt;
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}

	public void stop() {
		try {
			out.writeInt(-1);
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}

	@Override
	public void run() {
		int s = size();
		System.out.println("size: " + s);
		for (int i = 0; i < s; i++) {
			int elt = get(i);
			System.out.println(elt);
		}
		stop();
	}

	public static void main(String[] args) throws UnknownHostException, IOException {
		System.out.println("Client is running");
		Socket s = new Socket("localhost", 55000);
		System.out.println("Connection established");
		System.out.println("Local port:" + s.getLocalPort());
		System.out.println("Local IP:" + s.getLocalAddress());
		System.out.println("Remote port:" + s.getPort());
		System.out.println("Remote IP:" + s.getInetAddress());
		//
		InputStream is = s.getInputStream();
		OutputStream os = s.getOutputStream();

		DataOutputStream out = new DataOutputStream(os);
		DataInputStream in = new DataInputStream(is);

		Client client = new Client(in, out);
		client.run();

		System.out.println("Closing");
		s.close();

	}
}
