package net.lecnam.info;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Server implements Runnable {
	
	DataInputStream in;
	DataOutputStream out;
	List<Integer> l = Arrays.asList(1, 3, 5, 7, 9, 11, 13, 17);
	
	Server(DataInputStream in, DataOutputStream out) {
		this.in = in;
		this.out = out;
	}
	
	@Override
	public void run() {
		try {
			boolean done = false;
			while (!done) {
				int r = in.readInt();
				switch (r) {
					case -1 -> {
						done = true;
					}
					case -2 -> {
						int s = l.size();
						out.writeInt(s);
					}
					default -> {
						int elt = l.get(r);
						out.writeInt(elt);
					}
				}
			}
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}
	
	public static void main(String[] args) throws IOException {
		System.out.println("Server is running");
		ServerSocket ss = new ServerSocket(55000);
		System.out.println("Waiting for a client");
		Socket s = ss.accept();
		System.out.println("Client connected");
		System.out.println("Local port:" + s.getLocalPort());
		System.out.println("Local IP:" + s.getLocalAddress());
		System.out.println("Remote port:" + s.getPort());
		System.out.println("Remote IP:" + s.getInetAddress());
		//
		InputStream is = s.getInputStream(); 
		OutputStream os = s.getOutputStream();
		
		DataOutputStream out = new DataOutputStream(os);
		DataInputStream in = new DataInputStream(is);

		Server server = new Server(in, out);
		server.run();
		
		System.out.println("Closing");
		s.close();
		ss.close();
	}

}
