package net.lecnam.info.ex2;

import java.util.concurrent.BlockingQueue;
import java.util.logging.Logger;
import net.lecnam.info.ex2.Answer.Size;
import net.lecnam.info.ex2.Answer.Value;
import net.lecnam.info.ex2.Request.GetSize;
import net.lecnam.info.ex2.Request.GetValue;
import net.lecnam.info.ex2.Request.Stop;

public class Client implements Runnable {

	BlockingQueue<Answer> in;
	BlockingQueue<Request> out;

	Client(BlockingQueue<Answer> in, BlockingQueue<Request> out) {
		this.in = in;
		this.out = out;
	}
	
	static final Logger logger = Logger.getLogger("server");

	public int size() {
		try {
			Request request = new GetSize();
			out.put(request);
			Answer answer = in.take();
			logger.info("Answer: " + answer);
			switch (answer) {
				case Size(var s) -> {
					return s;
				}
				default -> {
					throw new Error("Invalid answer");
				}
			}
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	public Integer get(int index) {
		try {
			Request request = new GetValue(index);
			out.put(request);
			Answer answer = in.take();
			logger.info("Answer:" + answer);
			switch (answer) {
				case Value(var elt) -> {
					return elt;
				}
				default -> {
					throw new Error("Invalid answer");
				}
			}
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	public void stop() {
		try {
			Request request = new Stop();
			out.put(request);
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	@Override
	public void run() {
		int s = size();
		System.out.println("size: " + s);
		for (int i = 0; i < s; i++) {
			int elt = get(i);
			System.out.println(elt);
		}
		stop();
	}

}
