package net.lecnam.info.ex2;

import net.lecnam.info.*;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.logging.Level;
import java.util.logging.Logger;
import net.lecnam.info.ex2.Answer.Size;
import net.lecnam.info.ex2.Answer.Value;
import net.lecnam.info.ex2.Request.GetSize;
import net.lecnam.info.ex2.Request.GetValue;
import net.lecnam.info.ex2.Request.Stop;

public class Server implements Runnable {
	
	BlockingQueue<Request> in;
	BlockingQueue<Answer> out;
	List<Integer> l = Arrays.asList(1, 3, 5, 7, 9, 11, 13, 17);
	
	static final Logger logger = Logger.getLogger("server");
	
	Server(BlockingQueue<Request> in, BlockingQueue<Answer> out) {
		this.in = in;
		this.out = out;
	}
	
	@Override
	public void run() {
		try {
			boolean done = false;
			while (!done) {
				Request request = in.take();
				logger.info("Request: " + request);
				switch (request) {
					case Stop() -> {
						done = true;
					}
					case GetSize() -> {
						int s = l.size();
						Answer answer = new Size(s);
						out.put(answer);
					}
					case GetValue(var index) -> {
						int elt = l.get(index);
						Answer answer = new Value(elt);
						out.put(answer);
					}
				}
			}
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}
	
}
